<template>
  <i-wrapper top>
    <div class="container d-flex flex-column align-items-center">
      <div class="p-title">{{ $t(`Today`) }}</div>
      <div class="p-subtitle">{{ todayString }}</div>
      <img src="~assets/images/scientist-telescope.png" class="p-image" />
      <div class="p-section-title">{{ $t(`Planetary transits`) }}</div>
      <div
        v-for="planetaryTransit in planetaryTransits"
        :key="planetaryTransit.title"
        tag="div"
        class="p-card"
        @click="goToPlanetaryTransit({ planetaryTransitId: planetaryTransit.id })">
        <div class="p-card__title">{{ planetaryTransit.title }}</div>
        <div class="p-card__description">
          {{ planetaryTransit.description }}
        </div>
        <div class="p-card__content">
          <div class="p-card__details">
            <div class="p-card-detail">
              <b class="p-card-detail__title">
                {{ $t(`Transiting`) }} {{ $t(`planetNames.${planetaryTransit.firstPlanetName.toLowerCase()}`) }}:
              </b>
              {{ planetaryTransit.transitHouseTextIn }}
            </div>
            <div v-if="planetaryTransit.progress > 0" class="p-card-detail">
              <b class="p-card-detail__title">{{ $t(`Duration`) }}:</b> {{ planetaryTransit.durationString }}
            </div>
            <div v-else class="p-card-detail">
              <b class="p-card-detail__title">{{ $t(`Start date`) }}:</b> {{ planetaryTransit.transitionDateString }}
            </div>
            <div class="p-card-detail">
              <b class="p-card-detail__title">{{ $t(`Progress`) }}</b>
              <div class="p-card-detail-progress">
                <div class="p-card-detail-progress__filled" :style="{ width: `${planetaryTransit.progress * 100}%` }" />
              </div>
            </div>
            <div class="p-card-more">
              {{ $t(`Details`) }}
              <img src="~assets/images/details-right-arrow-blue.svg" class="p-card-more__arrow" />
            </div>
          </div>
          <div ref="map" class="p-card-map">
            <!-- <img src="~assets/images/planetary-map-small.svg" class="p-card-map__image" /> -->
          </div>
        </div>
      </div>
    </div>
    <i-unlock-full-access ref="iUnlockFullAccess" />
    <i-secure-account />
    <template #bottom>
      <i-bottom-panel />
    </template>
  </i-wrapper>
</template>

<script>
  import * as d3 from 'd3';
  import ordinalNumber from '~/utils/ordinal-number.js';
  import { mapState } from 'vuex';

  export default {
    layout: 'default',
    nuxtI18n: false,
    middleware: ['logged-in-only'],

    async asyncData({ $axios }) {
      let planetaryTransits = [];
      let todayString = null;
      let response = await $axios.get('pages/today');
      planetaryTransits = response.data.data.planetaryTransits;
      todayString = response.data.data.todayString;
      return { planetaryTransits, todayString };
    },

    data() {
      return {};
    },

    computed: {
      ...mapState(['auth']),
    },

    mounted() {
      if (!this.auth.user.unlockFullAccessClosedAt) {
        setTimeout(() => {
          this.$refs.iUnlockFullAccess.show();
        }, 250);
      }

      for (let planetaryTransit of this.planetaryTransits) {
        this.drawMap(planetaryTransit);
      }
    },

    methods: {
      ordinalNumber,

      getPlanetImagePath(planetName) {
        planetName = planetName.toLowerCase();
        let postfix = `${planetName}-w2${planetName === 'sun' ? '-variant-1' : ''}`;
        return require(`~/assets/images/planet-${postfix}.svg`);
      },

      drawMap(planetaryTransit) {
        let planetaryTransitIndex = this.planetaryTransits.indexOf(planetaryTransit);
        let size = 89;
        let labelsOffset = 8;
        let labelsOffsetBack = 2;
        let earthSize = 31;
        let normalPlanetSize = 13;
        let bigPlanetSize = 16;
        let distanceArrowSize = 6;
        let distanceArcOffset = 15;
        let sectorTextOffset = -7;

        let svg = d3
          .select(this.$refs.map[planetaryTransitIndex])
          .append('svg')
          .attr('width', '100%')
          .attr('height', '100%')
          .attr('viewBox', `0 0 ${size + labelsOffset * 2} ${size + labelsOffset * 2}`);

        let arc1 = d3
          .arc()
          .innerRadius(0)
          .outerRadius(size / 2 - 0.8)
          .startAngle(-((planetaryTransit.fillSectors.planetsAngles[0] - 90) * Math.PI) / 180)
          .endAngle(-((planetaryTransit.fillSectors.planetsAngles[1] - 90) * Math.PI) / 180);

        svg
          .append('path')
          .attr('class', 'arc')
          .attr('d', arc1)
          .attr('fill', '#F3F3F3')
          .attr(
            'transform',
            `translate(${labelsOffset + (size - 2) / 2 + 1}, ${labelsOffset + (size - 2) / 2 + 1}) rotate(${
              planetaryTransit.rotationOffset
            } 0 0)`
          );

        for (let angle of planetaryTransit.anglesOfAstrologicalHouses) {
          svg
            .append('line')
            .style('stroke', '#ddc4ca')
            .style('stroke-width', 0.5)
            .attr(
              'x1',
              labelsOffset +
                (size - 2) / 2 +
                1 +
                ((size - 2) / 2) * -Math.cos(((-angle + planetaryTransit.rotationOffset) * Math.PI) / 180)
            )
            .attr(
              'y1',
              labelsOffset +
                (size - 2) / 2 +
                1 +
                ((size - 2) / 2) * -Math.sin(((-angle + planetaryTransit.rotationOffset) * Math.PI) / 180)
            )
            .attr(
              'x2',
              labelsOffset +
                (size - 2) / 2 +
                1 +
                ((size - 2) / 2) * Math.cos(((-angle + planetaryTransit.rotationOffset) * Math.PI) / 180)
            )
            .attr(
              'y2',
              labelsOffset +
                (size - 2) / 2 +
                1 +
                ((size - 2) / 2) * Math.sin(((-angle + planetaryTransit.rotationOffset) * Math.PI) / 180)
            );
        }

        for (let circleIndex = 0; circleIndex < 4; ++circleIndex) {
          if (circleIndex === 0) {
            continue;
          }

          let circleSize = (size / 4) * (circleIndex + 1);

          svg
            .append('circle')
            .attr('cx', labelsOffset + (size - 2) / 2 + 1)
            .attr('cy', labelsOffset + (size - 2) / 2 + 1)
            .attr('r', (circleSize - 2) / 2)
            .style('fill', 'transparent')
            .style('stroke', circleIndex === 3 ? '#961937' : '#ddc4ca')
            .style('stroke-width', circleIndex === 3 ? 1 : 0.5);
        }

        for (let angle of planetaryTransit.degreesBetweenHousesAngles) {
          let angleIndex = planetaryTransit.degreesBetweenHousesAngles.indexOf(angle);

          svg
            .append('text')
            .attr('x', 0)
            .attr('y', 0)
            .attr('fill', '#000000')
            .attr('text-anchor', 'middle')
            .attr('dominant-baseline', 'central')
            .style('font-size', '30%')
            .attr(
              'transform',
              `translate(
                ${
                  labelsOffset +
                  (size - 2) / 2 +
                  1 +
                  ((size - 2) / 2 + labelsOffset - labelsOffsetBack) *
                    Math.cos(((-angle + planetaryTransit.rotationOffset) * Math.PI) / 180)
                }
                ${
                  labelsOffset +
                  (size - 2) / 2 +
                  1 +
                  ((size - 2) / 2 + labelsOffset - labelsOffsetBack) *
                    Math.sin(((-angle + planetaryTransit.rotationOffset) * Math.PI) / 180)
                }
              ) rotate(${
                (angle - planetaryTransit.rotationOffset + 3600) % 360 >= 180
                  ? -angle - 90 + planetaryTransit.rotationOffset
                  : -angle + 90 + planetaryTransit.rotationOffset
              } 0 0)`
            )
            .text(() => angleIndex + 1);
        }

        let arcRadius = (size / 2 / 4) * (planetaryTransit.distanceBetweenAngles.bigRadius ? 3 : 2);

        svg
          .append('image')
          .attr('href', require(`~/assets/images/distance-between-planets-arrow.svg`))
          .attr('x', -distanceArrowSize / 2)
          .attr('y', -distanceArrowSize / 2 - 1)
          .attr('width', distanceArrowSize)
          .attr('height', distanceArrowSize)
          .attr(
            'transform',
            `translate(${
              labelsOffset +
              (size - 2) / 2 +
              1 +
              (arcRadius - 0.8) *
                Math.cos(
                  ((-planetaryTransit.distanceBetweenAngles.planetsAngles[1] +
                    distanceArcOffset +
                    planetaryTransit.rotationOffset) *
                    Math.PI) /
                    180
                )
            } ${
              labelsOffset +
              (size - 2) / 2 +
              1 +
              (arcRadius - 0.8) *
                Math.sin(
                  ((-planetaryTransit.distanceBetweenAngles.planetsAngles[1] +
                    distanceArcOffset +
                    planetaryTransit.rotationOffset) *
                    Math.PI) /
                    180
                )
            }) rotate(${
              -planetaryTransit.distanceBetweenAngles.planetsAngles[1] +
              distanceArcOffset +
              planetaryTransit.rotationOffset +
              180
            } 0 0)`
          );

        let arc0 = d3
          .arc()
          .innerRadius(arcRadius - 0.8)
          .outerRadius(arcRadius)
          .startAngle(
            -(
              (planetaryTransit.distanceBetweenAngles.planetsAngles[0] - 90 - planetaryTransit.rotationOffset) *
              Math.PI
            ) / 180
          )
          .endAngle(
            -(
              (planetaryTransit.distanceBetweenAngles.planetsAngles[1] -
                90 -
                distanceArcOffset -
                planetaryTransit.rotationOffset) *
              Math.PI
            ) / 180
          );

        svg
          .append('path')
          .attr('class', 'arc')
          .attr('d', arc0)
          .attr('fill', '#961937')
          .attr('transform', `translate(${labelsOffset + (size - 2) / 2 + 1}, ${labelsOffset + (size - 2) / 2 + 1})`);

        svg
          .append('image')
          .attr('href', require(`~/assets/images/planet-earth-w1.svg`))
          .attr('width', earthSize)
          .attr('height', earthSize)
          .attr('x', labelsOffset + (size - 2) / 2 + 1 - earthSize / 2)
          .attr('y', labelsOffset + (size - 2) / 2 + 1 - earthSize / 2);

        for (let drawPlanet of planetaryTransit.drawPlanets) {
          let drawPlanetSize = drawPlanet.isBig ? bigPlanetSize : normalPlanetSize;
          let drawPlanetRadius = (size / 4) * (drawPlanet.bigRadius ? 3 : 2);

          svg
            .append('image')
            .attr('width', drawPlanetSize)
            .attr('height', drawPlanetSize)
            .attr(
              'x',
              labelsOffset +
                (size - 2) / 2 +
                1 +
                ((drawPlanetRadius - 2) / 2) *
                  Math.cos(((-drawPlanet.angle + planetaryTransit.rotationOffset) * Math.PI) / 180) -
                drawPlanetSize / 2
            )
            .attr(
              'y',
              labelsOffset +
                (size - 2) / 2 +
                1 +
                ((drawPlanetRadius - 2) / 2) *
                  Math.sin(((-drawPlanet.angle + planetaryTransit.rotationOffset) * Math.PI) / 180) -
                drawPlanetSize / 2
            )
            .attr('href', this.getPlanetImagePath(drawPlanet.name));
        }

        let sectorTextAngle =
          (planetaryTransit.fillSectors.planetsAngles[0] + planetaryTransit.fillSectors.planetsAngles[1]) / 2;

        svg
          .append('text')
          .attr('x', 0)
          .attr('y', 0)
          .attr('fill', '#961937')
          .attr('text-anchor', 'middle')
          .attr('dominant-baseline', 'central')
          .style('font-size', '30%')
          .text(() => `${planetaryTransit.directionDegrees}°`)
          .attr(
            'transform',
            `translate(
                ${
                  labelsOffset +
                  (size - 2) / 2 +
                  1 +
                  ((size - 2) / 2 + sectorTextOffset) *
                    Math.cos(((-sectorTextAngle + planetaryTransit.rotationOffset) * Math.PI) / 180)
                }
                ${
                  labelsOffset +
                  (size - 2) / 2 +
                  1 +
                  ((size - 2) / 2 + sectorTextOffset) *
                    Math.sin(((-sectorTextAngle + planetaryTransit.rotationOffset) * Math.PI) / 180)
                }
              ) rotate(${
                (sectorTextAngle - planetaryTransit.rotationOffset + 3600) % 360 >= 180
                  ? -sectorTextAngle - 90 + planetaryTransit.rotationOffset
                  : -sectorTextAngle + 90 + planetaryTransit.rotationOffset
              } 0 0)`
          );
      },

      goToPlanetaryTransit({ planetaryTransitId }) {
        if (!this.auth.user.hasActiveSubscription) {
          this.$refs.iUnlockFullAccess.show();
          return;
        }

        this.$router.push({
          name: 'planetary-transits.planetaryTransitId',
          params: { planetaryTransitId },
        });
      },
    },
  };
</script>

<style lang="scss" scoped>
  .p-title {
    color: #fff;
    font-size: rf(30px);
    font-weight: bold;
    text-align: center;
    margin-top: rs(5px);
  }

  .p-subtitle {
    color: #fff;
    font-size: rf(14px);
    text-align: center;
    margin-top: rs(3px);
  }

  .p-image {
    width: rs(160px);
    height: rs(170px);
    margin-top: rs(20px);
  }

  .p-section-title {
    width: 100%;
    color: #fff;
    font-size: rf(16px);
    font-weight: bold;
    margin-top: rs(20px);
    margin-left: rs(2px);
    margin-bottom: rs(10px);
  }

  .p-card {
    width: 100%;
    border-radius: rs(20px);
    background-color: #fff;
    box-shadow: 0 5px 10px rgba(0, 0, 0, 0.15);
    margin-bottom: rs(15px);
    padding: rs(15px);
    cursor: pointer;
  }

  .p-card__title {
    color: #524c62;
    font-size: rf(16px);
    font-weight: bold;
  }

  .p-card__description {
    display: block;
    display: -webkit-box;
    -webkit-line-clamp: 2;
    -webkit-box-orient: vertical;
    overflow: hidden;
    text-overflow: ellipsis;
    color: #524c62;
    font-size: rf(12px);
    margin-top: rs(5px);
    line-height: 140%;
  }

  .p-card__content {
    display: flex;
    width: 100%;
  }

  .p-card__details {
    flex-grow: 1;
    margin-top: rs(5px);
  }

  .p-card-detail {
    display: flex;
    align-items: center;
    font-size: rf(12px);
    margin-top: rs(5px);
    line-height: 140%;
  }

  .p-card-detail__title {
    margin-right: 0.25em;
  }

  .p-card-detail-progress {
    display: inline-block;
    width: rs(140px);
    height: rs(7px);
    background-color: rgba(#e6e6e6, 0.5);
    border-radius: rs(math.div(7px, 2));
    margin-left: rs(11px);
    overflow: hidden;
  }

  .p-card-detail-progress__filled {
    height: rs(7px);
    padding-left: rs(7px);
    box-sizing: content-box;
    transform: translateX(rs(-7px));
    border-radius: rs(math.div(7px, 2));
    background-color: #f78472;
  }

  .p-card-more {
    display: inline-flex;
    align-items: center;
    justify-content: space-between;
    // width: rs(85px);
    height: rs(20px);
    color: #4762f0;
    font-size: rf(14px);
    line-height: 140%;
    margin-top: rs(20px);
  }

  .p-card-more__arrow {
    width: rs(7px);
    height: rs(10px);
    margin-left: rs(10px);
  }

  .p-card-map {
    width: rs(103px);
    height: rs(103px);
    margin-top: rs(5px);
    flex-shrink: 0;
    flex-grow: 0;
  }

  .p-card-map__image {
    width: rs(103px);
  }
</style>
